#include <source.hpp>
using namespace QOSM::Propagation;
using namespace QOSM::EM;

QOSM::EM::Source::Source::Source(double freq_GHz){
    freq = freq_GHz * 1e9;
    k0 = 2*pi * freq / c0;
    lambda0 = 299792458. / freq;
}

FieldNx3 QOSM::EM::Source::Source::eField(const VectorNx3 &r_pts_src) const{
    FieldNx3 e_field(0);
    return e_field;
}

FieldNx3 QOSM::EM::Source::Source::hField(const VectorNx3 &r_pts_src) const{
    FieldNx3 h_field(0);
    return h_field;
}

std::tuple<FieldNx3, FieldNx3, VectorNx3> QOSM::EM::Source::Source::fields(const VectorNx3 &r_pts_src) const{
    FieldNx3 h_field(0);
    FieldNx3 e_field(0);
    VectorNx3 s_field(0);
    return {e_field, h_field, s_field};
}


std::tuple<FieldNx3, FieldNx3, VectorNx3> QOSM::EM::Source::Source::orientedFields(const VectorNx3 &r_pts_src, const Vec3 &z_probe_src) const{
    FieldNx3 h_field(0);
    FieldNx3 e_field(0);
    VectorNx3 s_field(0);
    return {e_field, h_field, s_field};
}